#include <epplet.h>
#include "asttimes.h"

/* Change the following */
/* ==================== */
#define ON "purple1.xpm"
#define OFF "purple0.xpm"
// Tucson - NOAO
//#define LONGITUDE 110.9481
//#define LONGITUDE 110.96
// My Longitude
#define LONGITUDE 110.968326
/* ==================== */
Epplet_gadget b_close, b_help, time_matrix[6][4], bacg, jday, ltd, lstd, utd,dum1,dum2,dum3;
Window     win,win2;
RGB_buf    buff;
int        minutes = 20, hours = 12, seconds = 0;

char buf[1024];
int x[6] = {3, 10, 17, 24, 31, 38};
int y[4] = {25, 18, 11, 4};
int state[6] = {0,0,0,0,0,0};
int bin_matrix[10][4] = {{0,0,0,0},
			 {1,0,0,0},
			 {0,1,0,0},
			 {1,1,0,0},
			 {0,0,1,0},
			 {1,0,1,0},
			 {0,1,1,0},
			 {1,1,1,0},
			 {0,0,0,1},
			 {1,0,0,1}};

static void cb_timer(void *data);
static void cb_close(void *data);
static void cb_in(void *data, Window w);
static void cb_out(void *data, Window w);
static void cb_expose(void *data, Window win, int x, int y, int w, int h);
static void draw_leds(void);
static void draw_julday(int h, int m, int s);
static void cb_help(void *data);

static void
cb_timer(void *data)
{
   struct tm           tim;
   struct tm          *tim2;
   time_t              t2;
   int                 h, m, s;

   t2 = time(NULL);
   tim2 = localtime(&t2);
   if (tim2)
     {
	memcpy(&tim, tim2, sizeof(struct tm));
	h = tim.tm_hour;
	m = tim.tm_min;
	s = tim.tm_sec;
	hours = (int)h + ((int)m / 60) + ((int)s / 3600);
	minutes = (int)m + ((int)s / 60);
	seconds = (int)s;
     }
   draw_leds();
   draw_julday(hours,minutes,seconds);
   Epplet_timer(cb_timer, NULL, 0.15, "TIMER");   
   data = NULL;
}

static void
cb_close(void *data)
{
   Epplet_unremember();
   Esync();
   data = NULL;
   exit(0);
}

static void
cb_in(void *data, Window w)
{
   if (w == Epplet_get_main_window())
     {
       Epplet_gadget_show(b_close);
       Epplet_gadget_show(b_help);
     }
   return;
   data = NULL;
}

static void
cb_out(void *data, Window w)
{
   if (w == Epplet_get_main_window())
     {
       Epplet_gadget_hide(b_close);
       Epplet_gadget_hide(b_help);
     }
   return;
   data = NULL;
}

static void
cb_expose(void *data, Window win, int x, int y, int w, int h)
{
   draw_leds();
   return;
   data = NULL;
   win = (Window) 0;
   x = y = w = h = 0;
}

static void
cb_help(void *data)
{
   Epplet_show_about("E-BinClock");
   return;
   data = NULL;
}

static void
draw_julday(int h, int m, int s)
{
   double julday;
   double gmttime;
   double epoch;
   double lst;
   int year, month, day, hour, minute, second;
   int hh,mm,ss;
   char jd[10],lt[10],st[10],ut[10];
   struct tm  gmt;
   struct tm  *gmt2;
   time_t t2;

   t2 = time(NULL);
   gmt2 = gmtime(&t2);

   if (gmt2)
   {

      memcpy(&gmt, gmt2, sizeof(struct tm));

      year   = gmt.tm_year;
      month  = gmt.tm_mon;
      day    = gmt.tm_mday;
      hour   = gmt.tm_hour;
      minute = gmt.tm_min;
      second = gmt.tm_sec;

      gmttime = (double)hour + (double)minute/60 + (double)second/3600;
      epoch = ast_date_to_epoch ((int)year+1900, (int)month+1, (int)day, gmttime);
      lst = ast_mst(epoch,LONGITUDE);

      julday = ast_date_to_julday((int)year+1900, (int)month+1, (int)day, gmttime);
      hh = (int)lst;
      mm = (int)((lst-hh)*60);
      ss = (int)((((lst-hh)*60)-mm)*60);

      if (h < 10)
	 sprintf(lt,"0%li",h);
      else
	 sprintf(lt,"%li",h);

      if (m < 10)
	 sprintf(lt,"%s:0%li",lt,m);
      else
	 sprintf(lt,"%s:%li",lt,m);

      if (s < 10)
	 sprintf(lt,"%s:0%li",lt,s);
      else
	 sprintf(lt,"%s:%li",lt,s);

      if (hh < 10)
	 sprintf(st,"0%li",hh);
      else
	 sprintf(st,"%li",hh);

      if (mm < 10)
	 sprintf(st,"%s:0%li",st,mm);
      else
	 sprintf(st,"%s:%li",st,mm);

      if (ss < 10)
	 sprintf(st,"%s:0%li",st,ss);
      else
	 sprintf(st,"%s:%li",st,ss);

      if (hour < 10)
	 sprintf(ut,"0%li",hour);
      else
	 sprintf(ut,"%li",hour);

      if (minute < 10)
	 sprintf(ut,"%s:0%li",ut,minute);
      else
	 sprintf(ut,"%s:%li",ut,minute);

      if (second < 10)
	 sprintf(ut,"%s:0%li",ut,second);
      else
	 sprintf(ut,"%s:%li",ut,second);

      sprintf(jd,"JD: %10.7f",julday);

      Epplet_change_label(ltd,lt);
      Epplet_change_label(utd,ut);
      Epplet_change_label(lstd,st);
      Epplet_change_label(jday,jd);
   }
}


static void
draw_leds(void)
{
   int t[6];
   int i,j;
   
   Epplet_clear_window(win);
   t[0] = hours / 10;
   t[1] = hours % 10;
   t[2] = minutes / 10;
   t[3] = minutes % 10;
   t[4] = seconds / 10;
   t[5] = seconds % 10;
   for (i=0;i<6;i++) {
   	if (t[i] != state[i]) {
		state[i] = t[i];
		for (j=0;j<4;j++) {
			Epplet_gadget_destroy(time_matrix[i][j]);
			if (bin_matrix[t[i]][j] == 1)
         			Esnprintf(buf, sizeof(buf), EROOT "/epplet_data/E-BinClock/" ON);
			else if (bin_matrix[t[i]][j] == 0)
         			Esnprintf(buf, sizeof(buf), EROOT "/epplet_data/E-BinClock/" OFF);

         		Epplet_gadget_show(time_matrix[i][j] = Epplet_create_image(x[i], y[j], 5, 5, buf));
		}
	}
   }
   //free(t);
   Esync();
}


int
main(int argc, char **argv)
{
   Epplet_gadget drawingarea;
   int i,j;

   atexit(Epplet_cleanup);
   Epplet_Init("E-BinClock", "0.1", "Enlightenment BinClock Epplet",
	       6, 3, argc, argv, 0);
   Epplet_timer(cb_timer, NULL, 0.5, "TIMER");
//   Epplet_gadget_show(drawingarea = Epplet_create_drawingarea(2, 2, 44, 44));
//   win2 = Epplet_get_drawingarea_window(drawingarea);
//   buff = Epplet_make_rgb_buf(40, 40);
//   Epplet_paste_buf(buff, win2, 0, 0);

   b_close = Epplet_create_button(NULL, NULL, 
				  2, 2, 0, 0, "CLOSE", 0, NULL, 
				  cb_close, NULL);
   b_help = Epplet_create_button(NULL, NULL,
				 34, 2, 0, 0, "HELP", win, NULL,
				 cb_help, NULL);
   Esnprintf(buf, sizeof(buf), EROOT "/epplet_data/E-BinClock/bg.xpm");
   Epplet_gadget_show(bacg = Epplet_create_image(2,2,42,35,buf));
   Epplet_gadget_show(jday = Epplet_create_label(3,35,"JD ",1));
   Epplet_gadget_show(dum1 = Epplet_create_label(45, 3,"LT",1));
   Epplet_gadget_show(ltd  = Epplet_create_label(57, 3,"",1));
   Epplet_gadget_show(dum2 = Epplet_create_label(45,13,"UT",1));
   Epplet_gadget_show(utd  = Epplet_create_label(57,13,"",1));
   Epplet_gadget_show(dum3 = Epplet_create_label(45,23,"ST",1));
   Epplet_gadget_show(lstd = Epplet_create_label(57,23,"",1));
   for (i=0;i<6;i++) {
      for (j=0;j<4;j++) {
         Esnprintf(buf, sizeof(buf), EROOT "/epplet_data/E-BinClock/" OFF);
         Epplet_gadget_show(time_matrix[i][j] = Epplet_create_image(x[i], y[j], 5, 5, buf));
      }
   }
   win = Epplet_get_main_window();
   Epplet_register_focus_in_handler(cb_in, NULL);
   Epplet_register_focus_out_handler(cb_out, NULL);
   Epplet_register_expose_handler(cb_expose, NULL);
   Epplet_show();
   Epplet_Loop();
   return 0;
}
